require 'metasm'
require 'metasm/gui/gtk'

$VERBOSE = true

exe = Metasm::AutoExe.decode_file('../driver.sys')
dasm = exe.init_disassembler
dasm.parse_c_file '../driver.h'

# dasm entrypoint & ioctl callback
dasm.set_label_at(0x11a20, 'driver_ioctl')
entry = 'entrypoint'
ep = [entry, 'driver_ioctl']

dasm.disassemble_mainiter ep
dasm.disassemble_mainiter ep
w = Metasm::GtkGui::MainWindow.new.display(dasm, ep)
w.dasm_widget.focus_addr entry, 1
w.dasm_widget.views[1].set_font File.read('fontdesc')
w.signal_connect('destroy') { Gtk.main_quit }
Gtk.main

