
class Ia32_junkfilter < Ia32
	Intre = '-?[0-9a-f]+h?'
	Patterns = [
		# XXX escape '[', '+'
		# nops
		['mov (\w+), \1'],
		['lea (\w+), dword ptr \[\1(?:\+0)?\]'],
		['wait'],
		['pushfd', 'push eax', 'xor eax, eax', 'mov ax, cs', 'cmp eax, 9', 'jle 7', 'rdtsc', 'imul eax, ecx', 'jmp eax', 'pop eax', 'popfd'],
		['ro%2 %0, '+Intre, 'xchg %1, %0', 'ro%2 %1, '+Intre, 'xchg %1, %0'],
		['ro%2 %0, '+Intre, 'xchg %0, %1', 'ro%2 %1, '+Intre, 'xchg %0, %1'],
		['ro%0 %1, '+Intre, 'ro%0 %1, '+Intre],
		['push %0', 'pop %0'],
		['(?:sh|ro|sa)[rl] %0, 20h'],
		['push %0', 'xchg %1, dword ptr \[esp\]', 'pop %0', 'xchg (?:%1, %0|%0, %1)'],
		['pushfd', 'xchg %0, dword ptr \[esp\]', 'push %0', 'popfd', 'pop %0'],
		['push %0', 'lea %0, dword ptr \[ebx\+4\]', 'xor %0, %1', 'xchg %0, dword ptr \[esp\]', 'push %1', 'mov %1, dword ptr \[esp\+4\]', 'rol %1, \w+', 'mov dword ptr \[esp\+4\], %1', 'pop %1', 'pop dword ptr \[esp\-8\]'],
		['pushfd', 'push %0', 'call 0', 'add dword ptr \[esp\+0\], 24h', 'pop %0', 'push 89h', 'add dword ptr \[esp\], 179h', 'popfd', 'jnz -1', '.*', 'mov \w+, dword ptr .*', 'adc \w+, \w+', 'int 3', 'pop %0', 'popfd'],
		['pushfd', 'add %0, %1', 'sub %0, %1', 'popfd'],
		['push %0', 'call 0', 'pushfd', 'add dword ptr \[esp\+4\], 13h', 'popfd', 'pop %0', 'jmp -1', 'jmp %0', 'pop %0'],
		['ro%5 %0, '+Intre, 'push %0', 'push %1', 'call 0', 'pop %1', 'pushfd', 'xor %1, dword ptr \[%1\]', 'popfd', 'ro%5 dword ptr \[esp\+4\], '+Intre, 'pop %1', 'pop %0'],
		['ro%5 %0, '+Intre, 'push %0', 'push \w+', 'call 1', 'pushfd', 'add dword ptr \[esp\+4\], 1dh', 'popfd', 'ro%5 dword ptr \[esp\+8\], '+Intre, 'ret 4', 'add eax, 1000h', 'pop %0'],
		['pushad', 'mov \w+, \w+', 'rol \w+, \w+', 'popad'],
		['rol %0, '+Intre, 'push %0', 'push %1', 'call 0', 'pop %1', 'pushfd', 'xor %1, .*', 'popfd', 'rol dword ptr \[esp\+4\], '+Intre, 'pop %1', 'pop %0'],
		['push %0', 'lea %0, .+', '%6 %0, .+', 'xchg %0, dword ptr \[esp\]', '%7 dword ptr \[esp\], \w+', 'pop dword ptr \[esp\-\w+\]'],
		['push %0', 'lea %0, .+', 'pushfd', '%6 %0, .+', 'popfd', 'xchg %0, dword ptr \[esp\]', '%7 dword ptr \[esp\], \w+', 'pop dword ptr \[esp\-\w+\]'],
		['push %0', 'lea %0, .+', '%6 %0, .+', 'xchg %0, dword ptr \[esp\]', 'pushfd', '%7 dword ptr \[esp\], \w+', 'popfd', 'pop dword ptr \[esp\-\w+\]'],
		['push %0', 'lea %0, .+', 'pushfd', '%6 %0, .+', 'popfd', 'xchg %0, dword ptr \[esp\]', 'pushfd', '%7 dword ptr \[esp\], \w+', 'popfd', 'pop dword ptr \[esp\-\w+\]'],
		['pushad', '%1 %2, .+', 'popad'],
		['pushfd', 'push eax', 'xor eax, eax', 'mov ax, cs', 'cmp eax, 9', 'jle 7', 'rdtsc', 'imul eax, ecx', 'jmp eax', 'pop eax', 'popfd'],
		[],
		# non-nops
		['push @0', 'push ecx', 'mov cl, '+Intre, 'ro[lr] dword ptr \[esp\+4\], cl', 'pop ecx', 'pop @0'],	# rol @0, cst
		['push @0', 'push ecx', 'ro[lr] dword ptr \[esp\+4\], cl', 'pop ecx', 'pop @0'],	# rol @0, cl
		['push %0', 'mov %0, \w+', 'mov @1, %0', 'pop %0'],	# mov @1, \w+
		['push %0', 'mov @1, %0', 'pop %0'],	# mov @1, %0
		['push %0', 'mov %0, dword ptr \[esp\+4\]',           '%5 %0, \w+',          'mov dword ptr \[esp\+4\], %0', 'pop %0'],	# \w+ [esp], \w+
		['push %0', 'mov %0, dword ptr \[esp\+4\]', 'pushfd', '%5 %0, \w+', 'popfd', 'mov dword ptr \[esp\+4\], %0', 'pop %0'],
		['xor %0, '+Intre, 'xor %0, '+Intre],
		['push %0', '%2 %0, @1', 'push %0', 'mov %0, dword ptr \[esp\+4\]', 'pop @3', 'pop dword ptr \[esp\-\w+\]'],
		['pushfd', 'pushad', 'rdtsc'],
		['push %0', 'push %1', 'pushfd', 'rdtsc'],
		['rdtsc', 'add %0, %1', 'jmp %0'],
		['xor e%0, e\1', 'mov %0, cs', 'cmp e%0, 0ah', 'jle \w+'],
		['call 0', 'pop %0', 'cmp %0, 7fffffffh', 'jnb \w+'],
		['(?:lea|mov) %0, .*', 'pop %0'],
		['pushfd', 'xor \w+, '+Intre, 'popfd'],
		['push %0', 'mov %0, @1', 'mov dword ptr \[ebx\+%2h\], %0', 'pop %0', 'push dword ptr \[ebx\+%2h\]', 'pop %3'],
		['push %0', 'mov %0, @1', 'pop dword ptr \[esp\-8\]'],
		['push %0', 'push %0', 'mov %0, dword ptr \[esp\+4\]', 'pop @1', 'pop dword ptr \[esp\-8\]'],
		['mov dword ptr \[ebx\+%0h\], %1', 'push dword ptr \[ebx\+%0h\]', 'pop @2'],
	]

	attr_accessor :dasm, :showrdtsc

	# returns a decodedinstruction to replace the full pattern
	def apply_pattern(pat, diseq, edata)
		di = DecodedInstruction.new(self)
		case pat
		when ['pushfd', 'pushad', 'rdtsc'], ['push %0', 'push %1', 'pushfd', 'rdtsc']
			puts "rdtsc at #{Expression[edata.ptr]}" if $DEBUG
			failover_ptr = edata.ptr
			state = 0
			sawjmp = false
			di.opcode = @opcode_list.find { |op| op.name == 'nop' }
			loop do
				ndi = decode_findopcode(edata)
				ndi = decode_instr_op(edata, ndi) if ndi
				raise 'rdtsc unfinished' if not ndi
				if ndi.opcode.props[:setip]
					if sawjmp
						puts 'rdtsc with more than 1 jmp'
						edata.ptr = failover_ptr
						return diseq.last
					end
					sawjmp = true
					if dasm and a = @dasm.sections.index(edata)
						ptr = edata.ptr
						l = @dasm.auto_label_at(ndi.instruction.args.first+a+ptr, 'rdtsc')
						@dasm.addrs_todo << [l] if @showrdtsc
						edata.ptr = ptr
					end
				end
				if pat.length == 3
					if ndi.opcode.name == 'popfd' and state == 1: break
					elsif ndi.opcode.name == 'popad': state = 1
					else state = 0
					end
				elsif pat.length == 4
					if    state == 2 and ndi.instruction.to_s == diseq[0].instruction.to_s.sub('push', 'pop'): break
					elsif state == 1 and ndi.instruction.to_s == diseq[1].instruction.to_s.sub('push', 'pop'): state = 2
					elsif ndi.opcode.name == 'popfd': state = 1
					else  state = 0
					end
				end
			end

		when ['push @0', 'push ecx', 'mov cl, '+Intre, 'ro[lr] dword ptr \[esp\+4\], cl', 'pop ecx', 'pop @0']
			di.opcode = @opcode_list.find { |op| op.name == diseq[3].opcode.name and op.args == [:modrm, :u8] }
			di.instruction.args = [diseq[0].instruction.args.first, diseq[2].instruction.args.last]
		when ['push @0', 'push ecx', 'ro[lr] dword ptr \[esp\+4\], cl', 'pop ecx', 'pop @0']
			di = diseq[2]
			di.instruction.args[0] = diseq[0].instruction.args.first
		when ['push %0', 'mov %0, \w+', 'mov @1, %0', 'pop %0']
			di.opcode = @opcode_list.find { |op| op.name == diseq[1].opcode.name and op.args == [:modrm, diseq[1].opcode.args.last] }
			di.instruction.args = [diseq[2].instruction.args.first, diseq[1].instruction.args.last]
		when ['push %0', 'mov @1, %0', 'pop %0']
			di = diseq[1]
		when ['push %0', 'mov %0, dword ptr \[esp\+4\]',           '%5 %0, \w+',          'mov dword ptr \[esp\+4\], %0', 'pop %0'],
		     ['push %0', 'mov %0, dword ptr \[esp\+4\]', 'pushfd', '%5 %0, \w+', 'popfd', 'mov dword ptr \[esp\+4\], %0', 'pop %0']
			pat = pat.dup
			while i = pat.index('pushfd') || pat.index('popfd')
				diseq.delete_at(i) ; pat.delete_at(i)
			end
			di.opcode = @opcode_list.find { |op| op.name == diseq[2].opcode.name and op.args == [:modrm, diseq[2].opcode.args.last] }
			mrm = diseq[1].instruction.args.last
			mrm.imm = nil
			di.instruction.args = [mrm, diseq[2].instruction.args.last]
		when ['xor %0, '+Intre, 'xor %0, '+Intre]
			di = diseq[0]
			di.instruction.args[-1] = Expression[Expression[diseq[0].instruction.args[-1], :^, diseq[1].instruction.args[-1]].reduce]
		when ['push %0', '%2 %0, @1', 'push %0', 'mov %0, dword ptr \[esp\+4\]', 'pop @3', 'pop dword ptr \[esp\-\w+\]']
			di = diseq[1]
			di.instruction.args[0] = diseq[4].instruction.args.first
		when ['rdtsc', 'add %0, %1', 'jmp %0']
			di.opcode = @opcode_list.find { |op| op.name == 'jmp' and op.args == [:i8] }
			di.instruction.args = [Expression[-diseq.inject(0){ |s,d| s+d.bin_length }]]
		when ['xor e%0, e\1', 'mov %0, cs', 'cmp e%0, 0ah', 'jle \w+'],
		     ['call 0', 'pop %0', 'cmp %0, 7fffffffh', 'jnb \w+']
			di.opcode = @opcode_list.find { |op| op.name == 'jmp' and op.args == [:i8] }
			di.instruction.args = diseq.last.instruction.args
		when ['(?:lea|mov) %0, .*', 'pop %0']
			di = diseq[1]
		when ['pushfd', 'xor \w+, '+Intre, 'popfd']
			di = diseq[1]
		when ['push %0', 'mov %0, @1', 'mov dword ptr \[ebx\+%2h\], %0', 'pop %0', 'push dword ptr \[ebx\+%2h\]', 'pop %3']
			di.opcode = diseq[1].opcode
			di.instruction.args = [diseq.last.instruction.args.last, diseq[1].instruction.args.last]
		when ['push %0', 'mov %0, @1', 'pop dword ptr \[esp\-8\]']
			di = diseq[1]
		when ['push %0', 'push %0', 'mov %0, dword ptr \[esp\+4\]', 'pop @1', 'pop dword ptr \[esp\-8\]']
			di.opcode = @opcode_list.find { |op| op.name == 'mov' and op.args == [:modrm, :reg] }
			di.instruction.args = [diseq[3].instruction.args.first, diseq[1].instruction.args.first]
		when ['mov dword ptr \[ebx\+%0h\], %1', 'push dword ptr \[ebx\+%0h\]', 'pop @2']
			di.opcode = @opcode_list.find { |op| op.name == 'mov' and op.args == [:modrm, :reg] }
			di.instruction.args = [diseq.last.instruction.args.first, diseq[0].instruction.args.last]
		else
			raise 'pattern apply fuxored ' + pat.inspect if Patterns.index(pat) >= Patterns.index([])
			di.opcode = @opcode_list.find { |op| op.name == 'nop' }
		end
		di.instruction.opname = di.opcode.name
		di
	end

	# returns true if all strings match pat
	# use %n to forward a \w+, @n to forward .+   will not match push[fa]?|pop[fa]?|esp
	# do not use the same variable twice when using it for the first time
	def pattern_match(pat, diseq)
		return false if pat.empty? or diseq.empty?
		str = diseq.map { |di| di.instruction.to_s }
		matches = []
		pat.zip(str).all? { |pt, st|
			next false if not st
			wantmatch = []
			pt = pt.gsub(/([%@])(\d)/) {
				type = $1
				i = $2.to_i
				if matches[i]: Regexp.escape(matches[i])
				else wantmatch << i ; { '%' => '(\w+)', '@' => '(.+)' }[type]
				end
			}
			if c = /^#{pt}$/i.match(st)
				wantmatch.each_with_index { |wm, i|
					matches[wm] = c.captures[i]
					return false if matches[wm] =~ /^(push|pop|esp)[afd]*$/i
				}
				true
			end
		}
	end

	def decode_instr_op(edata, di)
		cptr = pptr = edata.ptr
		pptr -= di.instruction.prefix[:list].length if di.instruction.prefix and di.instruction.prefix[:list]
		return if not di = super

		@decoded_iop_cache ||= {}
		if i = @decoded_iop_cache[[edata, pptr]]
			edata.ptr = pptr + i.bin_length
			return i.dup
		end

		# scan for one pattern
		ndi = di
		fwd = []
		loop do
			fwd << ndi
			case fwd.last.instruction.to_s	# overlapping needs a special workaround (we do not have access to flow now)
			when 'jmp -1': edata.ptr -= 1
			when 'call 1': edata.ptr += 1
			end
			if pat = Patterns.find { |pat| pattern_match(pat, fwd) }
				puts "#{Expression[pptr]} pattern #{Patterns.index(pat)}" if $DEBUG
				di = apply_pattern(pat, fwd, edata)
				di.bin_length = edata.ptr - pptr
				ndi = di
				fwd = []
				next
				#break
			elsif not Patterns.find { |pat| pattern_match(pat[0, fwd.length], fwd) }
				puts "#{Expression[pptr]} #{fwd.map { |i| i.instruction.to_s }.inspect}" if $DEBUG and fwd.length > 2
				break
			end
			ndi = decode_findopcode edata
			ndi = decode_instr_op(edata, ndi) if ndi
			break if not ndi
		end

		edata.ptr = pptr + di.bin_length

		# aggregate
		if di and di.opcode.name == 'nop' and not edata.inv_export[edata.ptr]
			odi = di
			di = decode_findopcode(edata)
			di = decode_instr_op(edata, di) if di
			if di and di.opcode.name == 'jmp' and di.instruction.args.first == Expression[-di.bin_length]
				# jmp $ => jmp $
				di.instruction.args = [Expression[-di.bin_length-odi.bin_length]]
			end
			di.bin_length += odi.bin_length if di
			di ||= odi
			edata.ptr = pptr + di.bin_length
		end

		@decoded_iop_cache[[edata, pptr]] = di

		di
	end

end

